import java.io.*;

public class Main {
    public static void main(String[] args) {
        RedBlackTree tree = new RedBlackTree();
        tree.insert(1);
        tree.insert(2);
        tree.insert(3);
        tree.insert(4);
        tree.insert(5);
        tree.insert(6);
        tree.insert(7);
        tree.insert(8);
        tree.insert(9);
        tree.insert(10);
        tree.insert(11);
        tree.insert(12);
        tree.insert(13);
        tree.insert(14);
        tree.insert(15);
        tree.insert(16);
        tree.insert(17);
        tree.insert(18);
        tree.insert(19);
        tree.insert(20);
        tree.insert(21);
        tree.insert(22);
        tree.insert(23);
        System.out.println("\\n");
        print(System.out, tree.getRoot());
        // System.out.println("");
        // print(System.out, tree.getRoot());
    }
    // Tree tree = new Tree();
    //     tree.insert(1);
    //     tree.insert(2);
    //     tree.insert(3);
    //     tree.insert(4);
    //     tree.insert(5);
    //     tree.insert(6);
    //     tree.insert(7);
    //     tree.insert(8);
    //     tree.insert(9);
    //     tree.insert(10);
    //     tree.insert(12);
    //     tree.insert( 13);
    //     System.out.println("\\n");
    //     print(System.out, tree.getRoot());
    //     System.out.println("");
    //     tree.delete(8);
    //     print(System.out, tree.getRoot());

    public static String traversePreOrder(Node root) {

        if (root == null) {
            return "";
        }

        StringBuilder sb = new StringBuilder();
        sb.append(root.getData()).append(root.getColor().toString());

        String pointerRight = "└──";
        String pointerLeft = (root.getRight() != null) ? "├──" : "└──";

        traverseNodes(sb, "", pointerLeft, root.getLeft(), root.getRight() != null);
        traverseNodes(sb, "", pointerRight, root.getRight(), false);

        return sb.toString();
    }

    public static void traverseNodes(StringBuilder sb, String padding, String pointer, Node node,
                                     boolean hasRightSibling) {
        if (node != null) {
            sb.append("\n");
            sb.append(padding);
            sb.append(pointer);
            sb.append(node.getData()).append(node.getColor().toString());

            StringBuilder paddingBuilder = new StringBuilder(padding);
            if (hasRightSibling) {
                paddingBuilder.append("│  ");
            } else {
                paddingBuilder.append("   ");
            }

            String paddingForBoth = paddingBuilder.toString();
            String pointerRight = "└──";
            String pointerLeft = (node.getRight() != null) ? "├──" : "└──";

            traverseNodes(sb, paddingForBoth, pointerLeft, node.getLeft(), node.getRight() != null);
            traverseNodes(sb, paddingForBoth, pointerRight, node.getRight(), false);
        }
    }

    public static void print(PrintStream os, Node tree) {
        os.print(traversePreOrder(tree));
    }

}