public class Node {
    private int data;

    private Node left;
    private Node right;
    private Node parent; // red-black tree

    private int height; // AVL tree
    private COLOR color; // red-black tree

    public Node(int data) {
        this.data = data;
    }

    public int getData() {
        return data;
    }

    public COLOR getColor() {
        return  color;
    }

    public Node getLeft() {
        return left;
    }

    public void setLeft(Node left) {
        this.left = left;
    }

    public Node getRight() {
        return right;
    }

    public void setRight(Node right) {
        this.right = right;
    }

    public int getHeight() {
        return height;
    }

    public void setHeight(int height) {
        this.height = height;
    }

    public void setColor(COLOR color) {
        this.color = color;
    }

    public Node getParent() {
        return parent;
    }

    public void setParent(Node parent) {
        this.parent = parent;
    }
}
